#include <iostream>
using namespace std;
int main(int argc, char** argv) {
	ios_base::sync_with_stdio(false);
	
	string s;
	cin >>s;
	string x;
	cin >>x;
	string x2="";
	for(int i=0;i<s.size();i+=x.size())
	{
		x2+=x;
	}
	long long int m[x2.size()+1][s.size()+1];
	for(int i=0;i<x2.size()+1;i++)
	{
		for(int j=0;j<s.size()+1;j++)
		{
			m[i][j]=0;
		}
	}
	
	for(int i=1;i<x2.size()+1;i++)
	{
		for(int j=1;j<s.size()+1;j++)
		{
			if(x2[i-1]==s[j-1])
			{
				m[i][j]=m[i-1][j-1]+1;
			}
			else
			{
				m[i][j]=max(m[i][j-1],m[i-1][j]);
			}
		}
	}
	
	
	int br=m[x2.size()][s.size()]/x.size();
	
	
	
	
	
	cout <<br<<"\n";
	cout <<s<<"\n";
	return 0;
}